## golang-github-uber-go-tally 4.0.1

=== Makefile ===
export GO15VENDOREXPERIMENT=1

BENCH_FLAGS ?= -cpuprofile=cpu.pprof -memprofile=mem.pprof -benchmem
PKGS ?= $(shell glide novendor)
PKG_FILES ?= *.go example/*.go m3/*.go m3/customtransports m3/thriftudp
LINT_IGNORE = m3/thrift\|thirdparty
LICENSE_IGNORE = thirdparty

.PHONY: all
all: lint test

.PHONY: dependencies
dependencies:
	@echo "Installing Glide and locked dependencies..."
	glide --version || go get -u -f github.com/Masterminds/glide
	glide install
	@echo "Installing test dependencies..."
	go install ./vendor/github.com/axw/gocov/gocov
	go install ./vendor/github.com/mattn/goveralls
	@echo "Installing golint..."
	go install ./vendor/github.com/golang/lint/golint

.PHONY: lint
lint: gomodtidy
	@rm -rf lint.log
	@echo "Checking formatting..."
	@gofmt -d -s $(PKG_FILES) 2>&1 | grep -v '$(LINT_IGNORE)' | tee lint.log
	@echo "Installing test dependencies for vet..."
	@go test -i $(PKGS)
	@echo "Checking lint..."
	@$(foreach dir,$(PKGS),golint $(dir) 2>&1 | grep -v '$(LINT_IGNORE)' | tee -a lint.log;)
	@echo "Checking for unresolved FIXMEs..."
	@git grep -i fixme | grep -v -e vendor -e Makefile | grep -v '$(LINT_IGNORE)' | tee -a lint.log
	@echo "Checking for license headers..."
	@./check_license.sh | grep -v '$(LICENSE_IGNORE)' | tee -a lint.log
	@[ ! -s lint.log ]

.PHONY: gomodtidy
gomodtidy: go.mod go.sum
	go mod tidy
	@if ! git diff --quiet $^; then \
		echo "go mod tidy changed files:" && \
		git status --porcelain $^ && \
		false; \
	fi

.PHONY: test
test:
	go test -race -v $(PKGS)

.PHONY: examples
examples:
	mkdir -p ./bin
	go build -o ./bin/print_example ./example/
	go build -o ./bin/m3_example ./m3/example/
	go build -o ./bin/prometheus_example ./prometheus/example/
	go build -o ./bin/statsd_example ./statsd/example/

.PHONY: cover
cover:
	go test -cover -coverprofile cover.out -race -v $(PKGS)

.PHONY: coveralls
coveralls:
	goveralls -service=travis-ci || echo "Coveralls failed"

.PHONY: bench
BENCH ?= .
bench:
	@$(foreach pkg,$(PKGS),go test -bench=$(BENCH) -run="^$$" $(BENCH_FLAGS) $(pkg);)

=== debian/changelog ===
golang-github-uber-go-tally (4.0.1-1) unstable; urgency=medium

  * New upstream version.
  * d/rules: Drop override_dh_fixperms.

 -- Aloïs Micard <creekorful@debian.org>  Thu, 07 Oct 2021 09:03:52 +0200

golang-github-uber-go-tally (4.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #994084)

 -- Aloïs Micard <creekorful@debian.org>  Sat, 11 Sep 2021 16:23:20 +0200

=== debian/control ===
Source: golang-github-uber-go-tally
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Aloïs Micard <creekorful@debian.org>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-cactus-go-statsd-client-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-model-dev,
               golang-github-stretchr-testify-dev,
               golang-github-twmb-murmur3-dev,
               golang-go.uber-atomic-dev,
               golang-gopkg-validator.v2-dev,
               golang-prometheus-client-dev,
               golang-yaml.v2-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-uber-go-tally
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-uber-go-tally.git
Homepage: https://github.com/uber-go/tally
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/uber-go/tally

Package: golang-github-uber-go-tally-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-github-cactus-go-statsd-client-dev,
         golang-github-pkg-errors-dev,
         golang-github-prometheus-client-model-dev,
         golang-github-stretchr-testify-dev,
         golang-github-twmb-murmur3-dev,
         golang-go.uber-atomic-dev,
         golang-gopkg-validator.v2-dev,
         golang-prometheus-client-dev,
         golang-yaml.v2-dev,
         ${misc:Depends}
Description: Go metrics interface with fast metrics reporters (library)
 Tally provides a common interface for emitting metrics, while
 letting you not worry about the velocity of metrics emission.
 .
 By default it buffers counters, gauges and histograms at a specified
 interval but does not buffer timer values.  This is primarily so
 timer values can have all their values sampled if desired and if
 not they can be sampled as summaries or histograms independently by a
 reporter.

## golang-github-uber-go-tally 4.1.7

=== debian/changelog ===
golang-github-uber-go-tally (4.1.7-2) unstable; urgency=medium

  * Team upload
  * Fix atomic alignment issue on 32bit systems

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 08 Jul 2023 00:09:39 +0000

golang-github-uber-go-tally (4.1.7-1) unstable; urgency=medium

  * Team upload

  [ Aloïs Micard ]
  * update debian/gitlab-ci.yml (using pkg-go-tools/ci-config)

  [ Mathias Gibbens ]
  * New upstream release
  * d/control:
    - Update Standards-Version to 4.6.2 (no changes needed)
    - Update Build-Depends and Depends
  * Extend test timeout to 30 minutes in d/rules

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 17 Jun 2023 15:42:01 +0000

=== debian/control ===
--- 
+++ 
@@ -15,8 +15,9 @@
                golang-go.uber-atomic-dev,
                golang-gopkg-validator.v2-dev,
                golang-prometheus-client-dev,
+               golang-uber-goleak-dev,
                golang-yaml.v2-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-uber-go-tally
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-uber-go-tally.git
 Homepage: https://github.com/uber-go/tally
@@ -34,6 +35,7 @@
          golang-go.uber-atomic-dev,
          golang-gopkg-validator.v2-dev,
          golang-prometheus-client-dev,
+         golang-uber-goleak-dev,
          golang-yaml.v2-dev,
          ${misc:Depends}
 Description: Go metrics interface with fast metrics reporters (library)

## golang-github-uber-go-tally 4.1.10

=== debian/changelog ===
golang-github-uber-go-tally (4.1.10-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 11 Nov 2023 23:36:01 +0000

## golang-github-uber-go-tally 4.1.11

=== debian/changelog ===
golang-github-uber-go-tally (4.1.11-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Update Build-Depends and Depends in d/control

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 09 Feb 2024 18:24:04 +0000

## golang-github-uber-go-tally 4.1.16

=== debian/changelog ===
golang-github-uber-go-tally (4.1.16-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 23 Mar 2024 23:42:16 +0000

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
                dh-golang,
                golang-any,
                golang-github-cactus-go-statsd-client-dev,
+               golang-github-golang-mock-dev,
                golang-github-pkg-errors-dev,
                golang-github-prometheus-client-model-dev,
                golang-github-stretchr-testify-dev,
@@ -28,6 +29,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: golang-github-cactus-go-statsd-client-dev,
+         golang-github-golang-mock-dev,
          golang-github-pkg-errors-dev,
          golang-github-prometheus-client-model-dev,
          golang-github-stretchr-testify-dev,

## golang-github-uber-go-tally 4.1.17

=== Makefile ===
# "go install"-ed binaries will be placed here during development.
export GOBIN ?= $(shell pwd)/bin

BENCH_FLAGS ?= -cpuprofile=cpu.pprof -memprofile=mem.pprof -benchmem
GO_FILES = $(shell find . \
	   '(' -path '*/.*' -o -path './thirdparty/*' -prune ')' -o \
	   '(' -type f -a -name '*.go' ')' -print)
MODULES = . ./tools

LINT_IGNORE = m3/thrift\|thirdparty
LICENSE_IGNORE = m3/thrift\|thirdparty
STATICCHECK_IGNORE = m3/thrift\|thirdparty\|m3/resource_pool.go:.*releaseProto is unused\|m3/reporter.go:.* argument should be pointer-like to avoid allocations

GOLINT = $(GOBIN)/golint
STATICCHECK = $(GOBIN)/staticcheck

.PHONY: all
all: lint test

.PHONY: lint
lint: gofmt golint gomodtidy staticcheck license

.PHONY: golint
golint: $(GOLINT)
	@echo "Checking lint..."
	@$(eval LOG := $(shell mktemp -t log.XXXXX))
	@$(GOLINT) ./... | grep -v '$(LINT_IGNORE)' > $(LOG) || true
	@[ ! -s "$(LOG)" ] || \
		(echo "golint failed:" | \
		cat - $(LOG) && false)

$(GOLINT): tools/go.mod
	cd tools && go install golang.org/x/lint/golint

.PHONY: staticcheck
staticcheck: $(STATICCHECK)
	@echo "Checking staticcheck..."
	@$(eval LOG := $(shell mktemp -t log.XXXXX))
	@$(STATICCHECK) ./... | grep -v '$(STATICCHECK_IGNORE)' > $(LOG) || true
	@[ ! -s "$(LOG)" ] || \
		(echo "staticcheck failed:" | \
		cat - $(LOG) && false)

$(STATICCHECK):
	cd tools && go install honnef.co/go/tools/cmd/staticcheck

.PHONY: gofmt
gofmt:
	@echo "Checking formatting..."
	$(eval LOG := $(shell mktemp -t log.XXXXX))
	@gofmt -e -s -l $(GO_FILES) | grep -v '$(LINT_IGNORE)' > $(LOG) || true
	@[ ! -s "$(LOG)" ] || \
		(echo "gofmt failed. Please reformat the following files:" | \
		cat - $(LOG) && false)


.PHONY: gomodtidy
gomodtidy: go.mod go.sum
	@echo "Checking go.mod and go.sum..."
	@$(foreach mod,$(MODULES),\
		(cd $(mod) && go mod tidy) &&) true
	@if ! git diff --quiet $^; then \
		echo "go mod tidy changed files:" && \
		git status --porcelain $^ && \
		false; \
	fi

.PHONY: license
license: check_license.sh
	@echo "Checking for license headers..."
	$(eval LOG := $(shell mktemp -t log.XXXXX))
	@./check_license.sh | grep -v '$(LICENSE_IGNORE)' > $(LOG) || true
	@[ ! -s "$(LOG)" ] || \
		(echo "Missing license headers in some files:" | \
		cat - $(LOG) && false)

.PHONY: test
test:
	go test -race -v ./...

.PHONY: examples
examples:
	mkdir -p ./bin
	go build -o ./bin/print_example ./example/
	go build -o ./bin/m3_example ./m3/example/
	go build -o ./bin/prometheus_example ./prometheus/example/
	go build -o ./bin/statsd_example ./statsd/example/

.PHONY: cover
cover:
	go test -cover -coverprofile=cover.out -coverpkg=./... -race -v ./...
	go tool cover -html=cover.out -o cover.html

.PHONY: bench
BENCH ?= .
bench:
	go test -bench=$(BENCH) -run="^$$" $(BENCH_FLAGS) ./...

=== m3/thrift/Makefile ===
gen-thrift:
	@thrift --gen go:thrift_import="github.com/uber-go/tally/v4/thirdparty/github.com/apache/thrift/lib/go/thrift" -out . v1/v1.thrift && rm -rf v1/m3-remote
	@echo Generated v1 Go Thrift in metrics/m3/thrift/v1.
	@thrift --gen go:thrift_import="github.com/uber-go/tally/v4/thirdparty/github.com/apache/thrift/lib/go/thrift" -out . v2/v2.thrift && rm -rf v2/m3-remote
	@echo Generated v2 Go Thrift in metrics/m3/thrift/v2.
	@git apply thrift.diff
	@echo Applied thrift.diff.

=== debian/changelog ===
golang-github-uber-go-tally (4.1.17-1) unstable; urgency=medium

  * Team upload
  * New upstream release 4.1.7:
    - Fix race when reporting internal cardinality metrics

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 18 Oct 2025 06:00:07 -0400

golang-github-uber-go-tally (4.1.16-2) unstable; urgency=medium

  * Team upload
  * Convert patches to gbp-pq format
  * Add new 0002-Skip-non-compliant-Prometheus-metric-name-test.patch to fix
    building with golang-github-prometheus-common-dev >= 0.62.0

 -- Daniel Swarbrick <dswarbrick@debian.org>  Mon, 18 Aug 2025 11:56:54 +0000

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                golang-prometheus-client-dev,
                golang-uber-goleak-dev,
                golang-yaml.v2-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-uber-go-tally
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-uber-go-tally.git
 Homepage: https://github.com/uber-go/tally

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/uber-go/tally/tags .*/v?(\d\S*)\.tar\.gz debian
